package at.uniklu.mmis;

import javax.imageio.ImageIO;
import java.io.File;
import java.io.IOException;
import java.awt.image.BufferedImage;
import java.awt.image.WritableRaster;

/**
 * Implement your feature here ...
 */
public class Feature {
    double[] avgColor;

    public Feature() {

        // TODO: initialize feature instance

        // just a sample feature ...
        avgColor = new double[3];
        for (int i = 0; i < avgColor.length; i++) {
            avgColor[i] = 0d;
        }
    }

    /**
     * Static mekthod used in Main
     *
     * @param file
     * @return the extracted feature ...
     */
    static Feature extractFeature(File file) throws IOException {
        Feature result = new Feature();
        result.extract(file);
        return result;
    }

    /**
     * Extracts the feature from a given image file.
     * @param file
     * @throws IOException
     */
    public void extract(File file) throws IOException {
        BufferedImage img = ImageIO.read(file);
        WritableRaster raster = img.getRaster();

        // just for speed up, a buffer pixel
        int[] tmpPixel = new int[3];

        for (int x = 0; x < img.getWidth(); x++) {
            for (int y = 0; y < img.getHeight(); y++) {
                raster.getPixel(x,y,tmpPixel);

                // TODO: implement your feature here ...

                // for the sample feature:
                for (int i = 0; i < avgColor.length; i++) {
                    avgColor[i] += (double) tmpPixel[i] / (img.getHeight()*img.getWidth());
                }
            }
        }
    }

    public double getDistance(Feature f) {
        if (f.equals(this)) return 0d;
        double result = 0d;

        // TODO: implement distance function.

        // for the sample feature:
        for (int i = 0; i < avgColor.length; i++) {
            result += Math.abs(avgColor[i] - f.avgColor[i]);
        }


        assert(result>=0);
        return result;
    }
}
