package at.uniklu.mmis;

import java.io.File;
import java.io.FilenameFilter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.TreeSet;

/**
 * Image search engine ...
 */
public class Main {
    static HashMap<File, Feature> index = new HashMap<File, Feature>(1000);

    public static void main(String[] args) {
        indexFiles(new File("./wang-data-1000"));

        // sample search ....
        TreeSet<Result> resultTreeSet = search(new File("./wang-data-1000/1.jpg"));
        for (Iterator<Result> resultIterator = resultTreeSet.iterator(); resultIterator.hasNext();) {
            Result result = resultIterator.next();
            System.out.println("result = " + result.toString());
        }

        // TODO: implement error classification rate, precision @ 10 and MAP of your feature.
        //   * search for each one of the 1000 images
        //   * analyze each one of the result lists
        //   * with <img-num>.jpg -> img-num%100 gives you the class number
    }

    public static void indexFiles(File dir) {
        File[] files = dir.listFiles(new FilenameFilter() {
            public boolean accept(File dir, String name) {
                return name.toLowerCase().endsWith(".jpg");
            }
        });
        for (int i = 0; i < files.length; i++) {
            File file = files[i];
            try {
                index.put(file, Feature.extractFeature(file));
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public static TreeSet<Result> search(File f) {
        TreeSet<Result> results = new TreeSet<Result>();
        try {
            Feature feature = Feature.extractFeature(f);
            for (Iterator<File> iterator = index.keySet().iterator(); iterator.hasNext();) {
                File file = iterator.next();
                double distance = feature.getDistance(index.get(file));
                results.add(new Result(index.get(file), file, distance));
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return results;
    }
}
