package at.uniklu.mmis;

import java.io.File;

/**
 * Simple result class, allows for ordering in a TreeSet or an arbitrary Collection.
 */
public class Result implements Comparable{
    Feature feature;
    File file;
    double distance;

    public Result(Feature feature, File file, double distance) {
        this.feature = feature;
        this.file = file;
        this.distance = distance;
    }

    public Feature getFeature() {
        return feature;
    }

    public void setFeature(Feature feature) {
        this.feature = feature;
    }

    public File getFile() {
        return file;
    }

    public void setFile(File file) {
        this.file = file;
    }

    public double getDistance() {
        return distance;
    }

    public void setDistance(double distance) {
        this.distance = distance;
    }

    public int compareTo(Object o) {
        if (o instanceof Result) return (int) Math.signum(getDistance()-((Result)o).getDistance());
        return 0;
    }

    public String toString() {
        return distance + ": " + file;
    }
}
